#include "Math.h"
#include "Step_CYC10_I2C.h"
#define MPU6050_I2C_ADDR                  0x68

constexpr uint8_t MPU6050_POWER_CTL     = 0x6B;//电源管理寄存器的地址
constexpr uint8_t MPU6050_XYZ_GYRO      = 0x1B;//陀螺仪配置寄存器的地址
constexpr uint8_t MPU6050_XYZ_ACCEL     = 0x1C;//加速度传感器配置寄存器的地址
constexpr uint8_t MPU6050_FIFO_CTL      = 0x23;//FIFO使能寄存器的地址
constexpr uint8_t MPU6050_XYZ_GYRO_F    = 0x19;//陀螺仪采样率分频寄存器的地址
constexpr uint8_t MPU6050_INT_ENABLE    = 0x38;//中断使能寄存器的地址（引脚INT）
constexpr uint8_t MPU6050_USER_CTRL     = 0x6A;//用户控制寄存器的地址（引脚XDA,XCL）
   //constexpr uint8_t ADXL345_INT_ENABLE    = 0x2E;//寄存器的地址
   //constexpr uint8_t ADXL345_INT_MAP       = 0x2F;//寄存器的地址
float fRad2Deg  = 57.295779513f; 
float caldata[6]               ;

void MPU6050_init()
{
    
    //uint8_t t;
    
    //I2C.masterRead(MPU6050_I2C_ADDR, 0, &t, 1);

    //if (t != ADXL345_DEVICE_ID) {
    //    Serial.println ("ADXL345 device ID unrecognized!!!!!");
    //}

    I2C.masterWrite(MPU6050_I2C_ADDR, MPU6050_POWER_CTL, 0x00);//复位电源管理寄存器
    I2C.masterWrite(MPU6050_I2C_ADDR, MPU6050_XYZ_GYRO   , 0x18);//陀螺仪量程
    I2C.masterWrite(MPU6050_I2C_ADDR, MPU6050_XYZ_ACCEL  , 0x0);//加速度计量程
   //  I2C.masterWrite(MPU6050_I2C_ADDR, MPU6050_FIFO_CTL   , 0x0);//FIFO使能
    //I2C.masterWrite(MPU6050_I2C_ADDR, MPU6050_INT_ENABLE , 0x0);//
    //I2C.masterWrite(MPU6050_I2C_ADDR, MPU6050_USER_CTRL  , 0x0);//
   // I2C.masterWrite(ADXL345_I2C_ADDR, ADXL345_BW_RATE, 0x07);
   // I2C.masterWrite(ADXL345_I2C_ADDR, ADXL345_INT_MAP, 0x0);
   // I2C.masterWrite(ADXL345_I2C_ADDR, ADXL345_INT_ENABLE, 0x10);
    
   // I2C.masterWrite(ADXL345_I2C_ADDR, ADXL345_DATA_FORMAT, 0xB);
   // I2C.masterWrite(ADXL345_I2C_ADDR, ADXL345_FIFO_CTL, 0x80);

   // chceck_ADXL345_Interrupt_Status();
    
}


void get_MPU6050_XYZ_ACCEL(int16_t *pX, int16_t *pY, int16_t *pZ,int16_t *gX, int16_t *gY, int16_t *gZ)//获取3轴数据
{
    uint8_t buf1[6];
    uint8_t buf2[2];
    uint8_t buf3[6];
    int16_t temp;

   //t = chceck_ADXL345_Interrupt_Status();

    //if (t & 0x80)
    //{
     I2C.masterRead(MPU6050_I2C_ADDR, 0x3B, buf1, 6);
        
     temp = ((int16_t)buf1[0] << 8) | buf1[1];
        *pX = temp;
   
     temp = ((int16_t)buf1[2] << 8) | buf1[3]; 
        *pY = temp;
        
     temp = ((int16_t)buf1[4] << 8) | buf1[5] ;
        *pZ = temp;  


     I2C.masterRead(MPU6050_I2C_ADDR, 0x43, buf3, 6);
     temp = ((int16_t)buf3[0] << 8) | buf3[1]; 
        *gX = temp;
        
     temp = ((int16_t)buf3[2] << 8) | buf3[3] ;
        *gY = temp;  

     temp = ((int16_t)buf3[4] << 8) | buf3[5] ;
        *gZ = temp; 

} 
void Calibration()
{
int16_t x, y, z, gx, gy, gz;
float valSums[6] = {0.0f,0.0f,0.0f,0.0f,0.0f,0.0f};
int16_t val[6][2000];

for (int j = 0; j < 2000; ++j)
{
    get_MPU6050_XYZ_ACCEL(&x, &y, &z, &gx, &gy, &gz);
    val[0][j] = x;
    val[1][j] = y;
    val[2][j] = z;
    val[3][j] = gx;
    val[4][j] = gy;
    val[5][j] = gz;
    valSums[0]   = valSums[0]+ val[0][j];
    valSums[1]   = valSums[1]+ val[1][j];
    valSums[2]   = valSums[2]+ val[2][j];
    valSums[3]   = valSums[3]+ val[3][j];
    valSums[4]   = valSums[4]+ val[4][j];
    valSums[5]   = valSums[5]+ val[5][j];
}
for (int i = 0; i < 6; ++i)
 {
    caldata[i] = (valSums[i] / 2000); 
 }
  caldata[2] -= 16384; //设芯片Z轴竖直向下，设定静态工作点。
}

void setup() {  
    delay(1000);
   Serial.println ("pitch=");
    MPU6050_init();
    Calibration();
    // SEVEN_SEG_DISPLAY.start_refresh();
   

   //  attachInterrupt (INT_UART_RX_INDEX, uart_rx_isr, RISING);
   // attachInterrupt (INT_EXTERNAL_1ST, int0_keys_isr, RISING);

    //interrupts();
}

void loop() 
{
  int16_t x, y, z,gx,gy,gz;


  get_MPU6050_XYZ_ACCEL (&x, &y, &z,&gx, &gy, &gz);
  x = float(x -  caldata [0])/1638.4f;
  y = float(y -  caldata [1] )/1638.4f;
  z = float(z -  caldata [2] )/1638.4f;
  gx =float(gx-  caldata [3] )/16.384f;
  gy =float(gy-  caldata [4] )/16.384f;
  gz =float(gz-  caldata [5])/16.384f;
  float fNorm   = sqrt(x *x + y * y + z * z);
  float fNormXZ = sqrt(x *x + z * z);
  float fTan1   = x / z;
  float roll    = acos(fTan1) * fRad2Deg;
  if( y<0 )
  {roll = -roll ;}

  float fNormYZ = sqrt(y *y + z * z);
  float fTan2   = y / z;
  float pitch   = acos(fTan2) * fRad2Deg; 
  if( x<0 )
  {pitch = -pitch;}
  Serial.println ( caldata [0]);
  Serial.println ( caldata [1]);
  Serial.println ( caldata [2]);
  Serial.println ( caldata [3]);   
  Serial.println ( caldata [4]);
  Serial.println ( caldata [5]); 
    delay(1000);
}

  
